require "defines"
require "util"


script.on_event(defines.events.on_research_finished, function(event) 
    local research = event.research
	local f = research.force
	local n = research.name
	
	
		if n == "laser-turret-damage-6" then
			for k, s in pairs (game.surfaces) do
				for c in s.get_chunks() do
					for key, b in pairs(s.find_entities_filtered({area={{c.x * 32, c.y * 32}, {c.x * 32 + 32, c.y * 32 + 32}}, name = "laser-turret-blue"})) do
						if b.force == f then
							local p = b.position
							b.destroy()
							s.create_entity{name = "laser-turret-purple", position = p, force = f}
						end				
					end
				end
			end		
		

		else if n == "laser-turret-damage-4" then
			for k, s in pairs (game.surfaces) do
				for c in s.get_chunks() do
					for key, b in pairs(s.find_entities_filtered({area={{c.x * 32, c.y * 32}, {c.x * 32 + 32, c.y * 32 + 32}}, name = "laser-turret-green"})) do
						if b.force == f then
							local p = b.position
							b.destroy()
							s.create_entity{name = "laser-turret-blue", position = p, force = f}
						end				
					end
				end
			end		
		
		
		else if n == "laser-turret-damage-2" then
			for k, s in pairs (game.surfaces) do
				for c in s.get_chunks() do
					for key, b in pairs(s.find_entities_filtered({area={{c.x * 32, c.y * 32}, {c.x * 32 + 32, c.y * 32 + 32}}, name = "laser-turret-red"})) do
						if b.force == f then
							local p = b.position
							b.destroy()
							s.create_entity{name = "laser-turret-green", position = p, force = f}
						end				
					end
				end
			end		
		end	
	end
	end
	end
     
)

function BuiltEntity(event)
--	game.players[1].print("builtentity")
	

	if event.created_entity.name == "laser-turret" then	
		local e = event.created_entity
		local s = e.surface
		local p = e.position
		local f = e.force
		local d = e.direction

				if f.technologies["laser-turret-damage-6"].researched  == true then
					e.destroy()
					s.create_entity{name = "laser-turret-purple", position = p, force = f, direction = d} 
				else
				if f.technologies["laser-turret-damage-4"].researched  == true then
					e.destroy()
					s.create_entity{name = "laser-turret-blue", position = p, force = f, direction = d} 
				else
				if f.technologies["laser-turret-damage-2"].researched  == true then
					e.destroy()
					s.create_entity{name = "laser-turret-green", position = p, force = f, direction = d} 
				end
		
	end
end
end
end

script.on_configuration_changed(function(data)
   if data.mod_changes ~= nil and data.mod_changes["Laser_Beam_Turret"] ~= nil and data.mod_changes["Laser_Beam_Turret"].old_version == nil then
   for k, f in pairs (game.forces) do
				if f.technologies["laser-turret-damage-6"].researched  == true then
					for k, s in pairs (game.surfaces) do
				for c in s.get_chunks() do
					for key, b in pairs(s.find_entities_filtered({area={{c.x * 32, c.y * 32}, {c.x * 32 + 32, c.y * 32 + 32}}, name = "laser-turret"})) do
						if b.force == f then
							local p = b.position
							b.destroy()
							s.create_entity{name = "laser-turret-purple", position = p, force = f}
						end				
					end
				end
			end	
				else
				if f.technologies["laser-turret-damage-4"].researched  == true then
					for k, s in pairs (game.surfaces) do
				for c in s.get_chunks() do
					for key, b in pairs(s.find_entities_filtered({area={{c.x * 32, c.y * 32}, {c.x * 32 + 32, c.y * 32 + 32}}, name = "laser-turret"})) do
						if b.force == f then
							local p = b.position
							b.destroy()
							s.create_entity{name = "laser-turret-blue", position = p, force = f}
						end				
					end
				end
			end	
				else
				if f.technologies["laser-turret-damage-2"].researched  == true then
					for k, s in pairs (game.surfaces) do
				for c in s.get_chunks() do
					for key, b in pairs(s.find_entities_filtered({area={{c.x * 32, c.y * 32}, {c.x * 32 + 32, c.y * 32 + 32}}, name = "laser-turret"})) do
						if b.force == f then
							local p = b.position
							b.destroy()
							s.create_entity{name = "laser-turret-green", position = p, force = f}
						end				
					end
				end
			end	
				end
	end
	end
	end
   end
 end)


script.on_event(defines.events.on_built_entity, BuiltEntity)
script.on_event(defines.events.on_robot_built_entity, BuiltEntity)